unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var
  OS: TOSVersionInfo;
  bOsVersionInfoEx : Boolean;
  OS_Desc: String;
begin
//  ZeroMemory(@OS,SizeOf(OS));
  OS.dwOSVersionInfoSize:=SizeOf(OS);
  bOsVersionInfoEx:=GetVersionEx(OS);
  Memo1.Clear;
  Memo1.Lines.Add('dwOSVersionInfoSize : '+IntToStr(OS.dwOSVersionInfoSize));
  Memo1.Lines.Add('dwMajorVersion : '+IntToStr(OS.dwMajorVersion));
  Memo1.Lines.Add('dwMinorVersion : '+IntToStr(OS.dwMinorVersion));
  Memo1.Lines.Add('dwBuildNumber : '+IntToStr(OS.dwBuildNumber));
  Memo1.Lines.Add('dwPlatformId : '+IntToStr(OS.dwPlatformId));
  Memo1.Lines.Add('szCSDVersion : '+OS.szCSDVersion);
  Memo1.Lines.Add('');
//  䴩 Memo1.Lines.Add(bOsVersionInfoEx);
//  䴩 Memo1.Lines.Add(OS.wProductType);

  case OS.dwPlatformId of
    VER_PLATFORM_WIN32_NT:
      begin
        if (( os.dwMajorVersion = 5) and (os.dwMinorVersion = 2 )) then OS_Desc:='Microsoft Windows Server 2003';
        if (( os.dwMajorVersion = 5) and (os.dwMinorVersion = 1 )) then OS_Desc:='Microsoft Windows XP';
        if ( os.dwMajorVersion = 5) and (os.dwMinorVersion = 0 ) then OS_Desc:='Microsoft Windows 2000';
        if ( os.dwMajorVersion <= 4 ) then OS_Desc:='Microsoft Windows NT';
      end;
    6..9: Caption := 'High';
    0, 10..99: Caption := 'Out of range';
  else
    OS_Desc:='N/A';
  end;

end;

end.
